## ebusd-25.1.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7.1 FATAL_ERROR)

# CMP0075 Include file check macros honor CMAKE_REQUIRED_LIBRARIES
# For more information see: https://cmake.org/cmake/help/latest/policy/CMP0075.html
if(POLICY CMP0075)
    cmake_policy(SET CMP0075 NEW)
endif()

file(STRINGS "VERSION" VERSION)

project(ebusd)

include(GNUInstallDirs)
include(CheckFunctionExists)
include(CheckCXXSourceRuns)
include(CheckIncludeFile)

set(PACKAGE ${CMAKE_PROJECT_NAME})
set(PACKAGE_NAME ${CMAKE_PROJECT_NAME})
set(PACKAGE_TARNAME ${CMAKE_PROJECT_NAME})
set(PACKAGE_VERSION ${VERSION})
set(PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
set(PACKAGE_BUGREPORT "ebusd@ebusd.eu")
set(PACKAGE_URL "https://github.com/john30/ebusd")
set(PACKAGE_PIDFILE "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/run/${PACKAGE}.pid")
set(PACKAGE_LOGFILE "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/log/${PACKAGE}.log")
execute_process(COMMAND echo -n ${VERSION}
                COMMAND sed "-e" "s/^\\([0-9]*\\.[0-9]*\\).*/\\1/" "-e" "s/\\.\\([0-9]\\)\$/0\\1/" "-e" "s/\\.//"
                OUTPUT_VARIABLE SCAN_VERSION)
execute_process(COMMAND echo -n ${VERSION}
                COMMAND sed "-e" "s/^\\([0-9]*\\.[0-9]*\\).*/\\1/" "-e" "s/^\\([0-9]*\\)\\..*$/\\1/"
                OUTPUT_VARIABLE PACKAGE_VERSION_MAJOR)
execute_process(COMMAND echo -n ${VERSION}
                COMMAND sed "-e" "s/^\\([0-9]*\\.[0-9]*\\).*/\\1/" "-e" "s/^.*\\.\\([0-9]*\\)$/\\1/"
                OUTPUT_VARIABLE PACKAGE_VERSION_MINOR)

execute_process(COMMAND git describe --always
                OUTPUT_VARIABLE REVISION
                OUTPUT_STRIP_TRAILING_WHITESPACE
                WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
if(NOT REVISION)
  execute_process(COMMAND date +p%Y%m%d
                  OUTPUT_VARIABLE REVISION
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
endif(NOT REVISION)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_FLAGS_DEBUG_INIT "-g -O0 -ggdb -fsanitize=address -fno-omit-frame-pointer")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX "" CACHE PATH "..." FORCE)
endif()

add_definitions(-fpic -Wall -Wno-unused-function -Wextra)

set(BUILD_SHARED_LIBS OFF)

check_include_file(arpa/inet.h HAVE_ARPA_INET_H)
check_include_file(dirent.h HAVE_DIRENT_H)
check_include_file(fcntl.h HAVE_FCNTL_H)
check_include_file(netdb.h HAVE_NETDB_H)
check_include_file(poll.h HAVE_POLL_H)
check_include_file(pthread.h HAVE_PTHREAD_H)
check_include_file(sys/ioctl.h HAVE_SYS_IOCTL_H)
check_include_file(sys/select.h HAVE_SYS_SELECT_H)
check_include_file(sys/time.h HAVE_SYS_TIME_H)
check_include_file(syslog.h HAVE_SYSLOG_H)
check_include_file(time.h HAVE_TIME_H)
check_include_file(termios.h HAVE_TERMIOS_H)
check_function_exists(cfsetspeed HAVE_CFSETSPEED)

set(CMAKE_REQUIRED_LIBRARIES pthread rt)
check_function_exists(pthread_setname_np HAVE_PTHREAD_SETNAME_NP)
check_function_exists(pselect HAVE_PSELECT)
check_function_exists(ppoll HAVE_PPOLL)
check_function_exists(timegm HAVE_TIMEGM)
check_include_file(linux/serial.h HAVE_LINUX_SERIAL -DHAVE_LINUX_SERIAL=1)
check_include_file(dev/usb/uftdiio.h HAVE_FREEBSD_UFTDI -DHAVE_FREEBSD_UFTDI=1)

option(coverage "enable code coverage tracking." OFF)
if(NOT coverage STREQUAL OFF)
  add_definitions(-g -O0 --coverage -Wall)
  link_libraries(gcov)
  message(STATUS "coverage enabled")
endif(NOT coverage STREQUAL OFF)

option(contrib "disable inclusion of contributed sources." ON)
if(contrib STREQUAL ON)
  set(HAVE_CONTRIB ON)
  message(STATUS "contrib enabled")
endif(contrib STREQUAL ON)

find_library(HAVE_MQTT mosquitto)
if(HAVE_MQTT)
  option(mqtt "disable support for MQTT handling." ON)
  if(mqtt STREQUAL ON)
    message(STATUS "MQTT enabled")
  else(mqtt STREQUAL ON)
    unset(HAVE_MQTT)
  endif(mqtt STREQUAL ON)
endif(HAVE_MQTT)

option(knx "disable support for KNX handling." ON)
if(knx STREQUAL ON)
  message(STATUS "KNX enabled")
  set(HAVE_KNX 1)
else(knx STREQUAL ON)
  unset(HAVE_KNX)
endif(knx STREQUAL ON)

if(HAVE_KNX)
  find_library(HAVE_KNXD eibclient)
  if(HAVE_KNXD)
    option(knxd "enable support for KNX handling via knxd." OFF)
    if(knxd STREQUAL ON)
      message(STATUS "KNX via knxd enabled")
    else(knxd STREQUAL ON)
      set(HAVE_KNXD 0)
    endif(knxd STREQUAL ON)
  endif(HAVE_KNXD)
endif(HAVE_KNX)

find_library(HAVE_SSL ssl)
find_library(LIB_CRYPTO crypto)
if(HAVE_SSL)
  if(LIB_CRYPTO)
    option(ssl "disable support for SSL." ON)
    if(ssl STREQUAL ON)
      message(STATUS "SSL enabled")
      set(CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES} ${HAVE_SSL} ${LIB_CRYPTO}")
    else(ssl STREQUAL ON)
      unset(HAVE_SSL)
    endif(ssl STREQUAL ON)
  else(LIB_CRYPTO)
    message(FATAL_ERROR "crypto library not available")
  endif(LIB_CRYPTO)
endif(HAVE_SSL)

check_cxx_source_runs("
#include <stdint.h>
int main() {
  union {
    uint32_t i;
    float f;
  } test;
  test.f = 0.15;
  return test.i == 0x3e19999a ? 0 : 1;
}
" HAVE_DIRECT_FLOAT_FORMAT)
if(NOT HAVE_DIRECT_FLOAT_FORMAT)
  check_cxx_source_runs("
#include <stdint.h>
int main() {
  union {
    uint32_t i;
    float f;
  } test;
  test.f = 0.15;
  return test.i == 0x9a99193e ? 0 : 1;
}
  " HAVE_DIRECT_FLOAT_FORMAT_REV)
  if(HAVE_DIRECT_FLOAT_FORMAT_REV)
    set(HAVE_DIRECT_FLOAT_FORMAT 2)
  endif(HAVE_DIRECT_FLOAT_FORMAT_REV)
endif(NOT HAVE_DIRECT_FLOAT_FORMAT)

add_definitions(-D_GNU_SOURCE -DHAVE_CONFIG_H)
configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${ebusd_SOURCE_DIR}/src)

if(BUILD_TESTING)
  enable_testing()
endif(BUILD_TESTING)

add_subdirectory(src/ebusd)
add_subdirectory(src/lib/utils)
add_subdirectory(src/lib/ebus)
add_subdirectory(src/lib/knx)
add_subdirectory(src/tools)

if(EXISTS "${ROOT}/etc/debian_version")
  install(FILES ${CMAKE_SOURCE_DIR}/contrib/debian/default/ebusd DESTINATION /etc/default/)
  install(FILES ${CMAKE_SOURCE_DIR}/contrib/debian/init.d/ebusd DESTINATION /etc/init.d/)
  install(FILES ${CMAKE_SOURCE_DIR}/contrib/debian/systemd/ebusd.service DESTINATION /lib/systemd/system/)
endif()
if(HAVE_MQTT)
  FILE(GLOB MQTT_CFG_FILES "${CMAKE_SOURCE_DIR}/contrib/etc/ebusd/mqtt-*.cfg")
  install(FILES ${MQTT_CFG_FILES} DESTINATION /etc/ebusd/)
endif(HAVE_MQTT)
if(HAVE_KNX)
  FILE(GLOB KNX_CFG_FILES "${CMAKE_SOURCE_DIR}/contrib/etc/ebusd/knx*.cfg")
  install(FILES ${KNX_CFG_FILES} DESTINATION /etc/ebusd/)
endif(HAVE_KNX)

=== src/ebusd/CMakeLists.txt ===
add_definitions(-Wconversion -Wno-unused-parameter)

set(ebusd_SOURCES
    bushandler.h bushandler.cpp
    datahandler.h datahandler.cpp
    request.h request.cpp
    network.h network.cpp
    mainloop.h mainloop.cpp
    scan.h scan.cpp
    main.h main.cpp main_args.cpp
)

if(HAVE_MQTT)
  set(ebusd_SOURCES ${ebusd_SOURCES} mqtthandler.cpp mqtthandler.h mqttclient.cpp mqttclient.h)
  set(ebusd_SOURCES ${ebusd_SOURCES} mqttclient_mosquitto.cpp mqttclient_mosquitto.h)
  set(ebusd_LIBS ${ebusd_LIBS} mosquitto)
endif(HAVE_MQTT)

if(HAVE_KNX)
  set(ebusd_SOURCES ${ebusd_SOURCES} knxhandler.cpp knxhandler.h)
  set(ebusd_LIBS ${ebusd_LIBS} knx)
  include_directories(../lib/knx)
endif(HAVE_KNX)

if(HAVE_SSL)
  set(ebusd_LIBS ${ebusd_LIBS} ssl crypto)
endif(HAVE_SSL)

if(HAVE_CONTRIB)
  set(ebusd_LIBS ${ebusd_LIBS} ebuscontrib)
endif(HAVE_CONTRIB)

include_directories(../lib/ebus)
include_directories(../lib/utils)

add_executable(ebusd ${ebusd_SOURCES})
target_link_libraries(ebusd utils ebus pthread rt ${ebusd_LIBS})

install(TARGETS ebusd EXPORT ebusd DESTINATION bin)

=== src/tools/CMakeLists.txt ===
add_definitions(-Wno-unused-parameter)

set(ebusctl_SOURCES ebusctl.cpp)
set(ebuspicloader_SOURCES ebuspicloader.cpp intelhex/intelhexclass.cpp)

include_directories(../lib/ebus)
include_directories(../lib/utils)
include_directories(intelhex)

add_executable(ebusctl ${ebusctl_SOURCES})
add_executable(ebuspicloader ${ebuspicloader_SOURCES})
target_link_libraries(ebusctl utils ebus ${ebusctl_LIBS})
target_link_libraries(ebuspicloader utils ${ebuspicloader_LIBS})

install(TARGETS ebusctl ebuspicloader EXPORT ebusd DESTINATION bin)

=== src/lib/ebus/CMakeLists.txt ===
add_definitions(-Wconversion -Wno-unused-parameter)

set(libebus_a_SOURCES
    result.h result.cpp
    symbol.h symbol.cpp
    filereader.h filereader.cpp
    datatype.h datatype.cpp
    data.h data.cpp
    device.h device_enhanced.h
    device_trans.h device_trans.cpp
    transport.h transport.cpp
    protocol.h protocol.cpp
    protocol_direct.h protocol_direct.cpp
    message.h message.cpp
    stringhelper.h stringhelper.cpp
)

if(HAVE_CONTRIB)
  add_subdirectory(contrib)
endif(HAVE_CONTRIB)

add_library(ebus ${libebus_a_SOURCES})
target_link_libraries(ebus utils ${libebus_a_LIBS})

if(BUILD_TESTING)
  add_subdirectory(test)
endif(BUILD_TESTING)

=== src/lib/knx/CMakeLists.txt ===
add_definitions(-Wconversion -Wno-unused-parameter)

set(libknx_a_SOURCES
    knx.h knx.cpp
)

set(libknx_a_LIBS
)

if(HAVE_KNXD)
    set(libknx_a_SOURCES ${libknx_a_SOURCES} knxd.h)
    set(libknx_a_LIBS ${libknx_a_LIBS} eibclient)
endif(HAVE_KNXD)

add_library(knx ${libknx_a_SOURCES})

target_link_libraries(knx ${libknx_a_LIBS})

=== src/lib/utils/CMakeLists.txt ===
add_definitions(-Wconversion)

set(libutils_a_SOURCES
    arg.h arg.cpp
    log.h log.cpp
    tcpsocket.h tcpsocket.cpp
    thread.h thread.cpp
    clock.h clock.cpp
    queue.h
    notify.h
    rotatefile.h rotatefile.cpp
    httpclient.h httpclient.cpp
)

add_library(utils ${libutils_a_SOURCES})

=== src/lib/ebus/contrib/CMakeLists.txt ===
add_definitions(-Wno-unused-parameter)

set(libebuscontrib_a_SOURCES
    contrib.h contrib.cpp
    tem.h tem.cpp
)

include_directories(..)

add_library(ebuscontrib ${libebuscontrib_a_SOURCES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif(BUILD_TESTING)

=== src/lib/ebus/test/CMakeLists.txt ===
add_definitions(-Wno-unused-parameter)

if(HAVE_CONTRIB)
  set(test_LIBS ${test_LIBS} ebuscontrib)
endif(HAVE_CONTRIB)

include_directories(..)
include_directories(../../utils)

add_executable(test_filereader test_filereader.cpp)
target_link_libraries(test_filereader ebus pthread)
add_test(filereader test_filereader)

add_executable(test_symbol test_symbol.cpp)
target_link_libraries(test_symbol ebus pthread)
add_test(symbol test_symbol)

add_executable(test_data test_data.cpp)
target_link_libraries(test_data ebus pthread ${test_LIBS})
add_test(data test_data)

add_executable(test_message test_message.cpp)
target_link_libraries(test_message ebus pthread ${test_LIBS})
add_test(message test_message)

include(CTest)

=== src/lib/ebus/contrib/test/CMakeLists.txt ===
include_directories(..)
include_directories(../..)
include_directories(../../../utils)

add_executable(test_contrib test_tem.cpp)
target_link_libraries(test_contrib ebus ebuscontrib pthread)
add_test(contrib test_contrib)

include(CTest)

=== contrib/alpine/APKBUILD ===
# Contributor: Tim <timstanleydev@gmail.com>
# Maintainer: John <ebusd@ebusd.eu>
pkgname=ebusd
pkgver=25.1
pkgrel=0
pkgdesc="Daemon for communication with eBUS heating systems"
url="https://github.com/john30/ebusd"
# Upstream only supports these archs.
arch="x86 x86_64 aarch64 armhf armv7"
license="GPL-3.0-only"
makedepends="cmake mosquitto-dev openssl-dev samurai"
source="$pkgname-$pkgver.tar.gz::https://github.com/john30/ebusd/archive/refs/tags/$pkgver.tar.gz"

build() {
	cmake -B build -G Ninja \
		-DCMAKE_BUILD_TYPE=MinSizeRel \
		-DBUILD_TESTING=ON
	cmake --build build
}

check() {
	ctest --output-on-failure --test-dir build
}

package() {
	DESTDIR="$pkgdir" cmake --install build --prefix /usr
}

sha512sums="
a4ab5e21f345894c29b7af84f46f93ac4a3ee658d69ca7fb002d52233e8c041043df328212cbeae4f01220e7a6bf4ec8a26ad3757eb0cf6da157d237f5b6b0b6  ebusd-24.1.tar.gz
"

=== contrib/archlinux/PKGBUILD ===
# Maintainer: John Baier <ebusd@ebusd.eu>
# Contributor: Milan Knizek <knizek volny cz>
# Usage: makepkg
pkgname=ebusd
pkgver=25.1
pkgrel=1
pkgdesc="ebusd, the daemon for communication with eBUS heating systems."
arch=('i686' 'x86_64' 'armv6h' 'armv7h' 'aarch64')
url=https://github.com/john30/ebusd/
license=('GPL3')
depends=('mosquitto' 'openssl' 'ca-certificates')
makedepends=()
optdepends=()
conflicts=('ebusd' 'ebusd-git')
provides=('ebusd')
install=ebusd.install
options=()
backup=('etc/conf.d/ebusd')
source=("https://github.com/john30/${pkgname}/archive/refs/tags/${pkgver}.tar.gz")

pkgver() {
  cat "${srcdir}/${pkgname}-${pkgver}/VERSION"|sed -e 's#-#_#g'
}

build() {
  cd "${srcdir}/${pkgname}-${pkgver}"
  ./autogen.sh
  make -j1
}

package() {
  cd "${srcdir}/${pkgname}-${pkgver}"
  make DESTDIR="$pkgdir" install-strip

  install -d                                              "${pkgdir}/usr/lib/systemd/system"
  install -m 0644 contrib/archlinux/systemd/ebusd.service "${pkgdir}/usr/lib/systemd/system"
  install -d                                              "${pkgdir}/etc/conf.d"
  install -m 0644 contrib/archlinux/conf.d/ebusd          "${pkgdir}/etc/conf.d/ebusd"
  install -d                                              "${pkgdir}/etc/ebusd"
  install -m 0644 contrib/etc/ebusd/mqtt-hassio.cfg       "${pkgdir}/etc/ebusd/mqtt-hassio.cfg"
  install -m 0644 contrib/etc/ebusd/mqtt-integration.cfg  "${pkgdir}/etc/ebusd/mqtt-integration.cfg"
}
# update md5sums: updpkgsums
md5sums=('ec614447defed756e586fdf4fd73647a')
